<?php
  /**************************************************************************\
  * phpGroupWare - projects                                                  *
  * (http://www.phpgroupware.org)                                            *
  * Written by Bettina Gille  [aeb@hansenet.de]                              *
  *          & Jens Lentfoehr <sw@lf.shlink.de>                              *
  * --------------------------------------------------------                 *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
/* $Id: edit.php,v 1.16 2001/01/07 22:11:32 bettina Exp $ */
  
    $phpgw_info["flags"]["currentapp"] = "projects";
    include("../header.inc.php");
    include($phpgw_info["server"]["api_inc"] . "/phpgw_utilities_sbox.inc.php");  
  
    $db2 = $phpgw->db;
  
    if (!$id) {
     Header("Location: " . $phpgw->link($phpgw_info["server"]["webserver_url"] . "/projects/"
	  . "sort=$sort&order=$order&query=$query&start=$start"
	  . "&filter=$filter"));
    }

    $common_hidden_vars =
   "<input type=\"hidden\" name=\"sort\" value=\"$sort\">\n"
 . "<input type=\"hidden\" name=\"order\" value=\"$order\">\n"
 . "<input type=\"hidden\" name=\"query\" value=\"$query\">\n"
 . "<input type=\"hidden\" name=\"start\" value=\"$start\">\n"
 . "<input type=\"hidden\" name=\"filter\" value=\"$filter\">\n"
 . "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";

    $t = new Template($phpgw_info["server"]["app_tpl"]);
    $t->set_file(array( "projects_edit" => "form.tpl"));
    $t->set_block("projects_edit", "add", "addhandle");
    $t->set_block("projects_edit", "edit", "edithandle");

    if ($phpgw_info["server"]["db_type"]=="pgsql") { $join = " JOIN "; }
    else { $join = " LEFT JOIN "; }

    if ($submit) {
    $errorcount = 0;

    if (!$num) { $error[$errorcount++] = lang('Please enter an ID for that Project !'); }

    $phpgw->db->query("select count(*) from p_projects where num='$num' AND id != '$id'");
    $phpgw->db->next_record(); 
    if ($phpgw->db->f(0) != 0) { $error[$errorcount++] = lang('That Project ID has been used already !'); } 

    if (checkdate($smonth,$sday,$syear)) { $sdate = mktime(2,0,0,$smonth,$sday,$syear); }
    else {
        if ($smonth && $sday && $syear) { $error[$errorcount++] = lang('You have entered an invalid start date !') . " : " . "$smonth - $sday - $syear"; }
    }
    if (checkdate($emonth,$eday,$eyear)) { $edate = mktime(2,0,0,$emonth,$eday,$eyear); }
      else {
        if ($emonth && $eday && $eyear) { $error[$errorcount++] = lang('You have entered an invalid end date !') . " : " . "$emonth - $eday - $eyear"; }
    }

    if ((!$ba_activities) && (!$bill_activities)) { $error[$errorcount++] = lang('Please choose an activity for that project first !'); }

    if (! $error) {
    $owner = $phpgw_info["user"]["account_id"];
    $descr = addslashes($descr);
    $title = addslashes($title);
    $num = addslashes($num);

    if ($access == "group") {
     if (count($n_groups) != 0) {
        $access = ",";
        $access .= implode(",",$n_groups);
        $access .= ",";
     } else
        $access = "private";            // Change to spit out an error
    }

      $phpgw->db->query("update p_projects set entry_date='" . time() . "', date='$sdate',"
                   . "end_date='$edate',coordinator='$coordinator',"
                   . "customer='$abid',status='$status',descr='$descr',title='$title',budget='$budget',access='$access' where id='$id'");

      $phpgw->db->query("delete from p_projectactivities where project_id='$id' and billable='N'");
       if (count($ba_activities) != 0) {
        while($activ=each($ba_activities)) {
           $phpgw->db->query("insert into p_projectactivities (project_id,activity_id,"
                       . "billable) values ('$id','$activ[1]','N')");
        }
      }

      $phpgw->db->query("delete from p_projectactivities where project_id='$id' and billable='Y'");
       if (count($bill_activities) != 0) {
        while($activ=each($bill_activities)) {
           $phpgw->db->query("delete from p_projectactivities where project_id='$id' and activity_id='$activ[1]' and billable='N'");
           $phpgw->db->query("insert into p_projectactivities (project_id,activity_id,"
                       . "billable) values ('$id','$activ[1]','Y')");
        }
      }
     }
    }

    if ($errorcount) { $t->set_var('message',$phpgw->common->error_list($error)); }
    if (($submit) && (! $error) && (! $errorcount)) { $t->set_var('message',lang("Project $num $title has been updated !")); }
    if ((! $submit) && (! $error) && (! $errorcount)) { $t->set_var('message',""); }

    if (isset($phpgw_info["user"]["preferences"]["common"]["currency"])) {
    $currency = $phpgw_info["user"]["preferences"]["common"]["currency"];
    $t->set_var('error','');
    $t->set_var('currency',$currency);
    } 
    else { $t->set_var('error',lang('Please select your currency in preferences !')); }

    $phpgw->db->query("select * from p_projects where id='$id'");
    $phpgw->db->next_record();     

    $t->set_var("addressbook_link",$phpgw->link("addressbook.php","query="));
    $t->set_var("addresses_link",$phpgw->link("addresses.php","query="));
    $t->set_var("actionurl",$phpgw->link("edit.php"));
    $t->set_var("deleteurl",$phpgw->link("delete.php"));
    $t->set_var("lang_action",lang("Edit project"));
    $t->set_var("common_hidden_vars",$common_hidden_vars);
    $t->set_var("lang_choose",'');
    $t->set_var("choose",'');

    $t->set_var("lang_num",lang("Project ID"));
    $t->set_var("num",$phpgw->strip_html($phpgw->db->f("num")));
    $t->set_var("lang_title",lang("Title"));
    $title  = $phpgw->strip_html($phpgw->db->f("title"));                                                                                                                               
    if (! $title)  $title  = "&nbsp;";                                                                                                                                                  
    $t->set_var("title",$title);
    $descrval  = $phpgw->strip_html($phpgw->db->f("descr"));                                                                                                                               
    if (! $descrval)  $descrval  = "&nbsp;";                                                                                                                                                  
    $t->set_var("descrval",$descrval);
    $t->set_var("lang_status",lang("Status"));
    if ($phpgw->db->f("status")=="active"):
         $stat_sel[0]=" selected";
     elseif ($phpgw->db->f("status")=="nonactive"):
         $stat_sel[1]=" selected";
     elseif ($phpgw->db->f("status")=="archiv"):
         $stat_sel[2]=" selected";
     endif;

     $status_list = "<option value=\"active\"".$stat_sel[0].">" . lang("active") . "</option>\n"
                  . "<option value=\"nonactive\"".$stat_sel[1].">" . lang("nonactive") . "</option>\n"
                  . "<option value=\"archiv\"".$stat_sel[2].">" . lang("archiv") . "</option>\n";

     $t->set_var("status_list",$status_list);

    $t->set_var("lang_budget",lang("Budget"));
    $t->set_var("budget",stripslashes($phpgw->db->f("budget")));
    $t->set_var('lang_end_date',lang('Date due'));
    $t->set_var("lang_start_date",lang("Start date"));

    $sdate = $phpgw->db->f("date");
    $edate = $phpgw->db->f("end_date");

    $sm = new sbox;

    if (!$sdate) {
        $smonth = date('m',time());
        $sday = date('d',time());
        $syear = date('Y',$sdate);
        }
    else {
        $smonth = date('m',$sdate);
        $sday = date('d',$sdate);
        $syear = date('Y',$sdate);
        }

    $t->set_var('start_date_select',$phpgw->common->dateformatorder($sm->getYears('syear',$syear),$sm->getMonthText('smonth',$smonth),$sm->getDays('sday',$sday)));

    if (!$edate) {
        $emonth = 0; 
        $eday = 0;
        $eyear = 0;
        }
    else {
        $emonth = date('m',$edate);
        $eday = date('d',$edate);
        $eyear = date('Y',$edate); 
        }

    $t->set_var('end_date_select',$phpgw->common->dateformatorder($sm->getYears('eyear',$eyear),$sm->getMonthText('emonth',$emonth),$sm->getDays('eday',$eday)));

    $t->set_var("lang_coordinator",lang("Coordinator"));
     
    $db2->query("SELECT account_id,account_firstname,account_lastname FROM accounts where "
                     . "account_status != 'L' ORDER BY account_lastname,account_firstname asc");
    while ($db2->next_record()) {
        $coordinator_list .= "<option value=\"" . $db2->f("account_id") . "\"";
        if($db2->f("account_id")==$phpgw->db->f("coordinator"))
            $coordinator_list .= " selected";
        $coordinator_list .= ">"        
                    . $phpgw->common->display_fullname($db2->f("account_id"),
                      $db2->f("account_firstname"),
                      $db2->f("account_lastname")) . "</option>";
     }
     $t->set_var("coordinator_list",$coordinator_list);  

// customer 
    $t->set_var("lang_select",lang("Select per button !"));
    $t->set_var("lang_customer",lang("Customer"));
    $abid = $phpgw->db->f("customer");

    if ($phpgw_info["apps"]["timetrack"]["enabled"]) {
    $db2->query("SELECT ab_id,ab_firstname,ab_lastname,ab_company_id,company_name FROM "
                     . "addressbook,customers where ab_company_id='$abid'");
    } 
    else {
    $db2->query("select ab_id,ab_lastname,ab_firstname,ab_company from addressbook where "
                        . "ab_id='$abid'");
    }
    $db2->next_record();
    if ($phpgw_info["apps"]["timetrack"]["enabled"]) { $company = $db2->f("company_name"); } 
    else { $company = $db2->f("ab_company"); }
    $t->set_var('name',$company . " [ " . $db2->f("ab_firstname") . " " . $db2->f("ab_lastname") . " ]"); 
    $t->set_var('abid',$abid);

// activites bookable
     $t->set_var("lang_bookable_activities",lang("Bookable activities"));
     $db2->query("SELECT p_activities.id as id,p_activities.descr,p_projectactivities.project_id FROM p_activities "
		     . "$join p_projectactivities ON (p_activities.id=p_projectactivities.activity_id) and  "
                     . "((project_id='$id') or (project_id IS NULL)) WHERE billable IS NULL OR billable='N' ORDER BY descr asc");
     while ($db2->next_record()) {
        $ba_activities_list .= "<option value=\"" . $db2->f("id") . "\"";
        if($db2->f("project_id"))
            $ba_activities_list .= " selected";
        $ba_activities_list .= ">"        
                    . $db2->f("descr")
                    . "</option>";
     }
     $t->set_var("lang_descr",lang("Description"));
     $t->set_var("ba_activities_list",$ba_activities_list);  

// activities billable
     $t->set_var("lang_billable_activities",lang("Billable activities"));
     $db2->query("SELECT p_activities.id as id,p_activities.descr,p_activities.billperae,p_projectactivities.project_id,p_projectactivities.billable"
		     . " FROM p_activities $join p_projectactivities ON "
                     . "(p_activities.id=p_projectactivities.activity_id) and  "
                     . "((project_id='$id') or (project_id IS NULL)) WHERE billable IS NULL OR billable='Y' ORDER BY descr asc");

     while ($db2->next_record()) {
        $bill_activities_list .= "<option value=\"" . $db2->f("id") . "\"";
        if($db2->f("billable")=="Y")
            $bill_activities_list .= " selected";
        $bill_activities_list .= ">"        
                    . $phpgw->strip_html($db2->f("descr")) . " " . $currency . " " . $db2->f("billperae")
                    . " " . lang("per workunit") . " " . "</option>";
     }
     $t->set_var("bill_activities_list",$bill_activities_list);  

    $t->set_var("lang_access_type",lang("Access type"));   
    $access_list = "<option value=\"private\"";
      		if ($phpgw->db->f("access") == "private")
              		$access_list .= " selected";
    $access_list .= ">" . lang("Private") . "</option>\n";
           
    $access_list .= "<option value=\"public\"";
       		if ($phpgw->db->f("access") == "public")
              		$access_list .= " selected";
    $access_list .= ">" . lang("Global public") . "</option>\n";

    $access_list .= "<option value=\"group\"";
       		if ($phpgw->db->f("access") != "public" && $phpgw->db->f("access") != "private")
	               $access_list .= " selected";
    $access_list .= ">" . lang("Group public") . "</option>\n";

    $_access = $phpgw->db->f("access");     

    $t->set_var("access_list",$access_list);
    $t->set_var("lang_which_groups",lang("Which groups"));
    
    $user_groups = $phpgw->accounts->read_group_names();

	       for ($i=0;$i<count($user_groups);$i++) {
                  $group_list .= "<option value=\"" . $user_groups[$i][0] . "\"";
		  if (ereg(",".$user_groups[$i][0].",",$phpgw->db->f("access")))
                  if (ereg(",".$user_groups[$i][0].",",$_access)) 
		     $group_list .= " selected";
		  $group_list .= ">" . $user_groups[$i][1] . "</option>\n";
	       }
    
    $t->set_var("group_list",$group_list);
    $t->set_var("lang_editsubmitb",lang("Edit"));
    $t->set_var("lang_editdeleteb",lang("Delete"));
    $t->set_var("lang_atvititiesb",lang("Activities"));
    
    $t->set_var("edithandle","");
    $t->set_var("addhandle","");
    $t->pparse("out","projects_edit");
    $t->pparse("edithandle","edit");

    $phpgw->common->phpgw_footer();
?>
