<?php
  /**************************************************************************\
  * phpGroupWare - projects                                                  *
  * (http://www.phpgroupware.org)                                            *
  * Written by Bettina Gille [aeb@hansenet.de]                               *                               
  *          & Jens Lentfoehr <sw@lf.shlink.de>                              *
  * -------------------------------------------------------                  *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: addactivity.php,v 1.12 2001/01/07 22:11:32 bettina Exp $ */
  
    $phpgw_info["flags"]["currentapp"] = "projects";
    include("../header.inc.php");

    $db2 = $phpgw->db;
  
  	$t = new Template($phpgw_info["server"]["app_tpl"]);
  	
  	$t->set_var("actionurl",$phpgw->link("addactivity.php"));
  	$t->set_file(array( "activity_add" => "formactivity.tpl"));
     	$t->set_block("activity_add", "add", "addhandle");
     	$t->set_block("activity_add", "edit", "edithandle");
  	
    if ($submit) {
    if ($choose) { $num = create_activityid($year); }
    else { $num = addslashes($num); }

    $errorcount = 0;
    if (!$num) { $error[$errorcount++] = lang('Please enter an ID for that Activity !'); }

    $phpgw->db->query("select count(*) from p_activities where num='$num'");
    $phpgw->db->next_record();
    if ($phpgw->db->f(0) != 0) { $error[$errorcount++] = lang('That Activity ID has been used already !'); }

    if ((!$billperae) || ($billperae==0)) { $error[$errorcount++] = lang('Please enter the bill per workunit !'); }
    if ((!$minperae) || ($minperae==0)) { $error[$errorcount++] = lang('Please enter the minutes per workunit !'); }

    if (! $error) {
    $descr = addslashes($descr);
    $phpgw->db->query("insert into p_activities (num,descr,remarkreq,billperae,minperae) "
                . "values ('$num','$descr','$remarkreq','$billperae','$minperae')"); 
        }
    }
    if ($errorcount) { $t->set_var('message',$phpgw->common->error_list($error)); }
    if (($submit) && (! $error) && (! $errorcount)) { $t->set_var('message',lang("Activity $num has been added !")); }
    if ((! $submit) && (! $error) && (! $errorcount)) { $t->set_var('message',''); }


   if (isset($phpgw_info["user"]["preferences"]["common"]["currency"])) {
   $currency = $phpgw_info["user"]["preferences"]["common"]["currency"];
   $t->set_var(error,"");
   }
   else {
   $t->set_var(error,lang("Please select your currency in preferences !"));
   }

	$t->set_var("lang_action",lang("Add activity"));
	
	$common_hidden_vars = "<input type=\"hidden\" name=\"start\" value=\"$start\">\n"
        		. "<input type=\"hidden\" name=\"order\" value=\"$order\">\n"
        		. "<input type=\"hidden\" name=\"filter\" value=\"$filter\">\n"
        		. "<input type=\"hidden\" name=\"query\" value=\"$query\">\n"
        		. "<input type=\"hidden\" name=\"sort\" value=\"$sort\">\n"
        		. "<input type=\"hidden\" name=\"id\" value=\"$id\">";
        		
    $t->set_var("common_hidden_vars",$common_hidden_vars);
    $t->set_var("lang_num",lang("Activity ID"));
    $t->set_var("num",$num);

    if (!$submit) {
    $choose = "<input type=\"checkbox\" name=\"choose\" value=\"True\">";
    $t->set_var("lang_choose",lang("Auto generate Activity ID ?"));
    $t->set_var("choose",$choose);
    }
    else {
    $t->set_var('lang_choose','');
    $t->set_var('choose','');
    }

    $t->set_var("lang_descr",lang("Description"));
    $t->set_var("descr",$descr);
    $t->set_var("lang_minperae",lang("Minutes per workunit"));
    $t->set_var("minperae",$minperae);
    $t->set_var(currency,$currency);
    $t->set_var("lang_billperae",lang("Bill per workunit"));
    $t->set_var("billperae",$billperae);

    $t->set_var("lang_remarkreq",lang("Remark required"));
    $remarkreq_list = "<option value=\"N\">" . lang("No") . "</option>\n"
           		. "<option value=\"Y\" selected>" . lang("Yes") . "</option>\n";
    $t->set_var("remarkreq_list",$remarkreq_list);

    $t->set_var("lang_addsubmitb",lang("Add"));
    $t->set_var("lang_addresetb",lang("Clear Form"));
        
    $t->set_var("edithandle","");
    $t->set_var("addhandle","");
    $t->set_var("acthandle","");
    $t->pparse("out","activity_add");
    $t->pparse("addhandle","add");

    $phpgw->common->phpgw_footer();
?>