<?php
  /**************************************************************************\
  * phpGroupWare - projects/projectdelivery                                  *
  * (http://www.phpgroupware.org)                                            *
  * Written by Bettina Gille  [aeb@hansenet.de]                              *
  *          & Jens Lentfoehr <sw@lf.shlink.de>                              *
  * --------------------------------------------------------                 *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
/* $Id: del_deliveryshow.php,v 1.7 2000/12/22 03:55:23 bettina Exp $ */
  
  $phpgw_info["flags"] = array("currentapp" => "projects",
                               "noheader" => True, 
                               "nonavbar" => True);         
  include("../header.inc.php");

  $t = new Template($phpgw_info["server"]["app_tpl"]);
  $t->set_file(array( "delivery_list_t" => "del_deliveryform.tpl",
                      "deliverypos_list"   => "del_deliveryform.tpl"));
  $t->set_block("delivery_list_t", "deliverypos_list", "list");

  if (isset($phpgw_info["user"]["preferences"]["projects"]["abid"])) {
    $t->set_var("error","");
     if ($phpgw_info["apps"]["timetrack"]["enabled"]) {
     $phpgw->db->query("SELECT ab_firstname,ab_lastname,ab_street,ab_zip,ab_city,ab_state,ab_company_id,company_name FROM "
                     . "addressbook,customers where "
                     . "ab_company_id='" .$phpgw_info["user"]["preferences"]["projects"]["abid"]."' and "
                     . "customers.company_id=addressbook.ab_company_id");
        }
      else {
    $phpgw->db->query("select ab_id,ab_lastname,ab_firstname,ab_street,ab_zip,ab_city,ab_state,ab_company from addressbook where "                                             
                        . "ab_id='" .$phpgw_info["user"]["preferences"]["projects"]["address"]."'");                                                                           
    }
    if ($phpgw->db->next_record()) {
    if ($phpgw_info["apps"]["timetrack"]["enabled"]) { $company = $phpgw->db->f("company_name"); }
    else { $company = $phpgw->db->f("ab_company"); }
      $t->set_var("ad_company",$company);
      $t->set_var("ad_firstname",$phpgw->db->f("ab_firstname"));
      $t->set_var("ad_lastname",$phpgw->db->f("ab_lastname"));
      $t->set_var("ad_street",$phpgw->db->f("ab_street"));
      $t->set_var("ad_zip",$phpgw->db->f("ab_zip"));
      $t->set_var("ad_city",$phpgw->db->f("ab_city"));
      $t->set_var("ad_state",$phpgw->db->f("ab_state"));
    }
    else {
      $t->set_var("ad_company","");
      $t->set_var("ad_firstname","");
      $t->set_var("ad_lastname","");
      $t->set_var("ad_street","");
      $t->set_var("ad_zip","");
      $t->set_var("ad_city","");
      $t->set_var("ad_state","");
      }
     }
   else {
    $t->set_var("error",lang("Please select your address in preferences!"));
    }

   $t->set_var("site_title",$phpgw_info["site_title"]);   
   $charset = $phpgw->translation->translate("charset");                                                                                                                                         
    $t->set_var('font',$phpgw_info["theme"]["font"]);
   $t->set_var("charset",$charset);   
   $t->set_var(lang_delivery,lang("Delivery ID"));      
   $t->set_var(lang_project,lang("Project"));      
   $t->set_var(lang_pos,lang("Position"));       
   $t->set_var(lang_workunits,lang("Workunits"));     
   $t->set_var(lang_delivery_date,lang('Delivery date')); 
   $t->set_var(lang_hours_date,lang('Job date'));      
   $t->set_var(lang_descr,lang("Description"));
  
   if ($phpgw_info["apps"]["timetrack"]["enabled"]) {
   $phpgw->db->query("SELECT p_delivery.customer,p_delivery.num,p_delivery.project_id,p_delivery.date, "
                 . "ab_company_id,company_name,ab_firstname,ab_lastname,ab_street,ab_zip, "
                 . "ab_city,p_projects.title FROM addressbook,customers,p_delivery,p_projects WHERE "
                 . "p_delivery.id=$delivery_id AND p_delivery.project_id=p_projects.id AND "
                 . "p_delivery.customer=ab_company_id AND customers.company_id=addressbook.ab_company_id");
    }
   else {    
   $phpgw->db->query("SELECT p_delivery.customer,p_delivery.num,p_delivery.project_id,p_delivery.date, "
                 . "ab_id,ab_company,ab_firstname,ab_lastname,ab_street,ab_zip, "
                 . "ab_city,p_projects.title FROM addressbook,p_delivery,p_projects WHERE "
                 . "p_delivery.id=$delivery_id AND p_delivery.customer=ab_id AND p_delivery.project_id=p_projects.id");
    }
   if ($phpgw->db->next_record()) {
	if ($phpgw_info["apps"]["timetrack"]["enabled"]) { $company = $phpgw->db->f("company_name"); }
	else { $company = $phpgw->db->f("ab_company"); }

   $t->set_var('company',$company);                                                                                                                                           
   $t->set_var("firstname",$phpgw->db->f("ab_firstname"));                                                                                                                                       
   $t->set_var("lastname",$phpgw->db->f("ab_lastname"));                                                                                                                                         
   $t->set_var("street",$phpgw->db->f("ab_street"));                                                                                                                                             
   $t->set_var("zip",$phpgw->db->f("ab_zip"));                                                                                                                                                   
   $t->set_var("city",$phpgw->db->f("ab_city"));

    $delivery_date = $phpgw->db->f("date");
    $month = $phpgw->common->show_date(time(),"n");
    $day   = $phpgw->common->show_date(time(),"d");
    $year  = $phpgw->common->show_date(time(),"Y");
    $delivery_date = $delivery_date + (60*60) * $phpgw_info["user"]["preferences"]["common"]["tz_offset"];
    $delivery_dateout =  $phpgw->common->show_date($delivery_date,$phpgw_info["user"]["preferences"]["common"]["dateformat"]);
    $t->set_var('delivery_date',$delivery_dateout);

   $t->set_var("delivery_num",$phpgw->strip_html($phpgw->db->f("num")));                                                                                                                         
   $title = $phpgw->strip_html($phpgw->db->f("title"));                                                                                                                                          
    if (! $title)  $title  = "&nbsp;";                                                                                                                                                           
   $t->set_var("title",$title);
   }
                                                                                                                                                                                                 
    $pos = 0;
    $sumaes=0;
    $phpgw->db->query("SELECT p_hours.remark,p_hours.minperae,p_hours.minutes,"                                                                                                        
                . "p_activities.descr,p_hours.date FROM p_hours,p_activities,p_deliverypos "
                . "WHERE p_deliverypos.hours_id=p_hours.id AND p_deliverypos.delivery_id=$delivery_id "
                . "AND p_hours.activity_id=p_activities.id");
   while ($phpgw->db->next_record()) {
	$pos++;
	$t->set_var("pos",$pos);
	$hours_date = $phpgw->db->f("date");
	if ($phpgw->db->f("date") == 0) { $hours_dateout = '&nbsp;'; }
	else {
        $month = $phpgw->common->show_date(time(),"n");
        $day   = $phpgw->common->show_date(time(),"d");
        $year  = $phpgw->common->show_date(time(),"Y");
        $hours_date = $hours_date + (60*60) * $phpgw_info["user"]["preferences"]["common"]["tz_offset"];
        $hours_dateout = $phpgw->common->show_date($hours_date,$phpgw_info["user"]["preferences"]["common"]["dateformat"]);
	}
	$t->set_var('hours_date',$hours_dateout);

	if ($phpgw->db->f("minperae") != 0) {                                                                                                                       
	$aes = ceil($phpgw->db->f("minutes")/$phpgw->db->f("minperae"));                                                                                            
	}                                                                                                                                                           
	$sumaes += $aes;

	$t->set_var('aes',$aes);
        $act_descr = $phpgw->strip_html($phpgw->db->f("descr"));                                                                                                                         
        if (! $act_descr)  $act_descr  = "&nbsp;";                                                                                                                                       
        $t->set_var("act_descr",$act_descr);
	$t->set_var("billperae",$phpgw->db->f("billperae"));
        $remark = $phpgw->strip_html($phpgw->db->f("remark"));                                                                                                                           
        if (! $remark)  $remark  = "&nbsp;";                                                                                                                                             
        $t->set_var('hours_remark',$remark);
        $t->parse("list", "deliverypos_list", true);
    }

    $t->set_var('lang_sumaes',lang('Sum workunits'));
    $t->set_var('sumaes',$sumaes);    

    $t->parse("out", "delivery_list_t", true);
    $t->p("out");
?>